// Data - class from which all ColdStore entities must derive
// Copyright (C) 1998,1999 Colin McCormack,
// see LICENSE (MD5 d7a11a4148f3858e544bf89cdde91727) for terms

static char *id __attribute__((unused))="$Id$";

#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <iostream.h>
#include <exception>
#include <string.h>
#include <dlfcn.h>
#include <qvmm.h>
#include <Q.hh>
#include <elf.hh>

/* InitElf looks for a NULL terminated array called autoload_elfs[]
 */
AutoLoad autoload_elfs[] = {
    {"../coldstore/libcold.so", Elf::COLDSTORE, NULL},
    {"./chaos.so", Elf::COLDSTORE, NULL},
    {NULL}
};

static int fd;

void bkpt()
{
}
 
void breakpoint()
{
}

void onError()
{
}
 
void ColdTerminate()
{
}
 
InitElf *initElf;

int main(int argc, char **argv)
{
    set_terminate(ColdTerminate);
    void *so = dlopen(NULL, RTLD_GLOBAL | RTLD_NOW);
    if (!so) {
        throw dlerror();
    }
#ifdef DEBUGLOG
        cerr << "dlopen() -> " << so << '\n';
#endif

    try {
        fd = Mmap::open("coldstore");	// construct the Mmap'd store
        initElf = new InitElf();	// initialize Elf module
    } catch (char *err) {
        cerr << "ERROR: " << err << " (?" << strerror(int errno) << ")\n";
        onError();
    }
    bkpt();
    delete initElf;
    Mmap::close(fd);
    close(fd);
}

void shutdown()
{
    cerr << "Shutdown";
    //    dlclose(elf_so);
    delete initElf;
    Mmap::close(fd);
    exit(0);
}
