// semantics of Chaos
// Copyright (C) 1998,1999 Colin McCormack, Jordan B. Baker
// see LICENSE (MD5 d7a11a4148f3858e544bf89cdde91727) for terms
// 	$Id

#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdexcept>
#include <iostream.h>
#include <strstream.h>
#include <typeinfo>
#include <dlfcn.h>
#include <stdlib.h>

#include <Data.hh>
#include <Store.hh>
#include <Tuple.hh>
#include <Segment.hh>
#include <String.hh>
#include <List.hh>
#include <Dict.hh>
#include <Symbol.hh>
#include <Error.hh>
#include <FlexLexer.h>

extern int running;
class Chaos
    : public List,
      public yyFlexLexer
{
    char *string;
    int strl;
    char *sp;
    int paren;

public:
    Chaos(const Slot& init);
    Chaos(istream *arg_yyin = NULL);
    void ChExit();
    ~Chaos();

    void ChPush(Slot el);
    Slot ChPop();

    void ChPrint(void);
    void ChDigit(const char *digits);
    void Chaos::ChReal(const char *digits);
    void ChString(const char *string);
    void ChBString(const char *string);
    void ChPrecision(const char *string);
    void ChFn(const char *name);
    void ChScope();
    void ChDup();
    void ChDrop();
    void ChSwap();
    void ChView();
    void ChDump();
    void ChNames();
    void ChThis();
    void ChBuiltins();
    void ChIf();
    void ChWhile();
    void ChEval();

    void ChNew();
    void ChTrue();
    void ChSum();
    void ChSub();
    void ChMult();
    void ChDiv();
    void ChMod();
    void ChVar(const char *);
    void ChSetVar();
    void ChPositive();
    void ChNegative();
    void ChInvert();
    void ChAnd();
    void ChXor();
    void ChOr();
    void ChLShift();
    void ChRShift();
    void ChType();
    void ChSequence();
    void ChIsSequence();
    void ChLength();
    void ChConcat();
    void ChSlice();
    void ChElement();
    void ChSearch();
    void ChRReplace();
    void ChReplace();
    void ChSReplace();
    void ChInsert();
    void ChRDel();
    void ChDel();
    void ChIterator();
    void ChIsIterator();
    void ChCurrent();
    void ChMore();
    void ChNext();
    void ChCall();
    void ChOpEq();
    void ChOpNEq();
    void ChOpGEq();
    void ChOpGT();
    void ChOpLEq();
    void ChOpLT();

    int yylex();
    int yywrap(void);
    void reset();
};

