// Error - ColdStore interface to Error
// Copyright (C) 1998,1999 Colin McCormack,
// see LICENSE (MD5 f5220f8f599e5e926f37cf32efe3ab68) for terms

static char *id __attribute__((unused))="$Id$";

#include "Data.hh"
#include "Store.hh"

#include "Tuple.hh"
#include "String.hh"
#include "Dict.hh"
#include "Symbol.hh"
#include "Error.hh"


Error::Error(const Error *err)
  : Tuple(-3),
    _err(err->_err),
    _value(err->_value),
    _explanation(err->_explanation)
{
}

Error::~Error()
{
}

extern void onError();
Error::Error(const char *err, const Slot &value, const char *expl)
    : Tuple(-3),	// Overlay the Tuple
      //_err(store->Errors->mkSym(err)),
      _value(value),
      _explanation(expl)
{
    onError();	// breakpoint opportunity
    _err = store->Errors->insert(err); //mkSym
}

// structural

// Uses the copy constructor
Data *Error::clone(void *where) const
{
    return new (where) Error(this);
}

// returns a mutable copy of this
Data *Error::mutate(void *where) const
{
    return clone(where);
}

// object's truth value
bool Error::truth() const
{
    return false;
}

ostream &Error::dump(ostream& out) const
{
    try {
        char *sym = ((Symbol*)_err)->name();
        out << '~' << sym << " {";
        _value.Dump(out);
        out << "} ";
        if ((bool)_explanation) {
            char *expl = _explanation;
            out << expl;
        }
    } catch (Error *e) {
        out << "recursive error: ";
        ((Tuple*)e)->dump(out);
        out << " on ";
        ((Tuple*)this)->dump(out);
    }

    return out;
}
