// Startup - Server Initialization
// Copyright (C) 1998,1999 Colin McCormack,
// see LICENSE (MD5 f5220f8f599e5e926f37cf32efe3ab68) for terms
//	$Id$

#ifndef STORE_HH
#define STORE_HH
class Builtin;
class Namespace;

//#include <qvmm.h>

class Object;

// Put the roots of the Store here
struct Store
{
    bool initialized;
    
    // DataType Managers
    Builtin *typeString;
    Builtin *typeBuiltin;
    Builtin *typeDict;
    Builtin *typeDictIt;
    Builtin *typeError;
    Builtin *typeInteger;
    Builtin *typeList;
    Builtin *typeNList;
    Builtin *typeNamespace;
    Builtin *typeUString;
    Builtin *typeSymbol;
    Builtin *typeTuple;
    Builtin *typeBigInt;
    Builtin *typeReal;
    
    // Well Known Objects
    Object *System;
    Object *Root;
    Namespace *Names;
    Namespace *Errors;	// distinguished namespace for Errors
    Namespace *Registered;	// registered Builtins

    Store(Builtin **table);
};

/** Initialization called after Elf loads the Coldstore library
 */
class Elf;
void initElf(Elf *elf);

/** Function to register Csyms as Builtins in the Registered Namespace
 */
void RegisterElf(Elf *elf);

extern Store *store;
//extern Memory *memory;

#endif
